# -*- coding: utf-8 -*-
# Author: Manuel de la Pena <manuel@canonical.com>
#
# Copyright 2011 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
"""Test the different main implementations."""

import sys

from twisted.internet import defer

from ubuntu_sso.tests import TOKEN

# Invalid name "BaseTestCase"
# pylint: disable=C0103

if sys.platform == 'win32':
    from ubuntu_sso.utils.tests.test_ipc import BaseIPCTestCase
    BaseTestCase = BaseIPCTestCase
else:
    from ubuntuone.devtools.testcases.dbus import DBusTestCase
    BaseTestCase = DBusTestCase

# pylint: enable=C0103


class FakedCredentials(object):
    """A very dummy Credentials object."""

    def find_credentials(self, *a, **kw):
        """Retrieve credentials."""
        return defer.succeed(TOKEN)

    def clear_credentials(self, *a, **kw):
        """Clear credentials."""
        return defer.succeed(None)

    def store_credentials(self, *a, **kw):
        """Store credentials."""
        return defer.succeed(None)

    def register(self, *a, **kw):
        """Register."""
        return defer.succeed(TOKEN)

    def login(self, *a, **kw):
        """Login."""
        return defer.succeed(TOKEN)
