# -*- coding: utf-8 -*-
#
# Copyright 2011-2012 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

"""The Qt graphical interface for the Ubuntu Single Sign On Client."""

import gettext
import collections


_ = gettext.gettext

ERROR_ALL = '__all__'
ERROR_MESSAGE = 'message'
LOCAL_FOLDERS_TITLE = _("Syncing your computer with the cloud")
LOCAL_FOLDERS_SPACE_HEADER = _("Space (%s)")
LOCAL_FOLDERS_OFFER_LABEL = _("The folders you have selected to sync "
    "take over your %(quota)s space. You can remove some folders or add "
    "some extra space")
LOCAL_FOLDERS_CALCULATING = _("Calculating")
NEXT = _("Next")


# Based on the gtk implementation
def build_general_error_message(errordict):
    """Build a user-friendly error message from the errordict."""
    result = ''
    if isinstance(errordict, collections.Mapping):
        msg1 = errordict.get(ERROR_ALL)
        msg2 = errordict.get(ERROR_MESSAGE)
        if msg2 is None:
            # See the errordict in LP: 828417
            msg2 = errordict.get('error_message')
        if msg1 is not None and msg2 is not None:
            result = '\n'.join((msg1, msg2))
        elif msg1 is not None:
            result = msg1
        elif msg2 is not None:
            result = msg2
        else:
            if 'errtype' in errordict:
                del errordict['errtype']
            result = '\n'.join(
                [('%s: %s' % (k, v)) for k, v in errordict.iteritems()])
    else:
        result = repr(errordict)
    return result
