# -*- coding: utf-8 -*-
#
# Copyright 2012 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

"""The test suite for Sign In UI."""

from PyQt4 import QtGui
from twisted.internet import defer

from ubuntu_sso.qt import sign_in_page as gui
from ubuntu_sso.qt.ui.choose_sign_in_ui import Ui_ChooseSignInPage
from ubuntu_sso.qt.tests import BaseTestCase, FakeMainWindow


class SignInPageTestCase(BaseTestCase):
    """Test the SignInPage code."""

    @defer.inlineCallbacks
    def setUp(self):
        """Initialize this test instance."""
        yield super(SignInPageTestCase, self).setUp()
        self.ui = gui.SignInPage(Ui_ChooseSignInPage(), QtGui.QPixmap())

    def test_show_event(self):
        """Check the page is initialized correctly."""
        wizard = FakeMainWindow()
        self.patch(self.ui, 'wizard', lambda *args: wizard)
        self.ui.initializePage()
        self.ui.show()
        self.addCleanup(self.ui.hide)
        self.assertTrue(self.ui.ui.existing_account_button.isDefault())
